/*
 * ext/ctype/ctype.c
 * 
 * by Eivind Eklund <eivind@FreeBSD.org>
 */

#include <ctype.h>

#include "ruby.h"
#include "rubyio.h"

static VALUE mCtype;

/*-------------------------- module Ctype --------------------------*/

#define def_is(a) 					\
static VALUE						\
ruby_is##a(m, c)					\
	VALUE m;					\
	VALUE c;					\
{							\
	return (is##a(NUM2INT(c)) ? Qtrue : Qfalse);	\
}

def_is(alnum)
def_is(alpha)
def_is(ascii)
def_is(blank)
def_is(cntrl)
def_is(digit)
def_is(graph)
def_is(hexnumber)
def_is(ideogram)
def_is(lower)
def_is(number)
def_is(phonogram)
def_is(print)
def_is(punct)
def_is(rune)
def_is(space)
def_is(special)
def_is(upper)
def_is(xdigit)
#undef def_is



/*------------------------- Initialization -------------------------*/
void
Init_ctype()
{
/* Extra R first to avoid reserved namespace 'STR*' */
#undef RSTRINGIZE
#define RSTRINGIZE(str) #str
    mCtype = rb_define_module("CType");
#define reg_is(a) rb_define_module_function(mCtype, RSTRINGIZE(a) "?", ruby_is##a, 1);
reg_is(alnum)
reg_is(alpha)
reg_is(ascii)
reg_is(blank)
reg_is(cntrl)
reg_is(digit)
reg_is(graph)
reg_is(hexnumber)
reg_is(ideogram)
reg_is(lower)
reg_is(number)
reg_is(phonogram)
reg_is(print)
reg_is(punct)
reg_is(rune)
reg_is(space)
reg_is(special)
reg_is(upper)
reg_is(xdigit)
#undef reg_is
#undef RSTRINGIZE
}
